//===================================RISCKER====================================
//------------------------------------------------------------------------------
//File Name:	RISCKER.v
//Purpose:		RISCKER instantiation
//Parameters:	None
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------

`timescale 1ns / 1ps

module RISCKER (
	input		CLK_50M,
	input		[3:0] SW,
	output reg[7:0] LED,
	input	[1:0] KE
	);

//////////////////////////////////////////////////////////////////
//=================Clock Frequency Division=======================
//////////////////////////////////////////////////////////////////
wire div_clk;

Generate_Arbitrary_Divided_Clk32 clk_div(
	.inclk(CLK_50M),
	.outclk(div_clk),
	.div_clk_count(12500000)
	);

//////////////////////////////////////////////////////////////////
//=======================RISCKER Processor========================
//////////////////////////////////////////////////////////////////
wire [25:0] status_out;
wire [15:0] output_port;
wire reset = KEY[0];

datapath RISC_inst (
    .clk(div_clk), 
	 .reset(reset),
    .input_port({12'b0,SW}),
    .output_port(output_port)
    );

assign LED = output_port[7:0];
	
endmodule 