//===================================RISCKER====================================
//=================================Left Shifter=================================
//------------------------------------------------------------------------------
//File Name:	shift_left.v
//Purpose:		Left shifter generate loop for mux instantiations
//Parameters:	w (width) s(shift amount)
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------
module shift_left # (parameter w=16, s=4) (rin, rout, shamt);

	input [w-1:0] rin;
	output [w-1:0] rout;
	input [s-1:0] shamt;

wire [w-1:0] path [w-1:0];
genvar i;

generate 
		for (i=0; i<w; i=i+1)
				begin:Logic_ShiftLeft

				
					assign path[i]={{rin[(w-1-i):0]},{i{1'b0}}};
				
				
					mux  mux_1	(.a(path[i]), 
									 .y(rout[w-1-i]), 
									 .sh(~shamt));
				end
		
endgenerate


endmodule
