//===================================RISCKER====================================
//===================================Shifters===================================
//------------------------------------------------------------------------------
//File Name:	shifter.v
//Purpose:		Instantiation and selection of shift and rotate operations
//Parameters:	w (width) s (shift amount)
//------------------------------------------------------------------------------
//=====================Alfredo Gualdron - Jose P. Pinilla=======================
//=================================Semillero ADT================================
//================================UPB Bucaramanga===============================
//Website:	http://semilleroadt.upbbga.edu.co/xiscker
//E-mail:	semilleroadt@gmail.com
//------------------------------------------------------------------------------

module shifter #(parameter w=16,s=4) ( a, shamt, shift_mode, y);

input [w-1:0] a;
input [1:0] shift_mode;
input [s-1:0] shamt;
output reg [w-1:0] y;

wire [w-1:0] left_out, rigth_out, rotate_out,arith_out;

//Output "Y" depends on the shift mode selected

always @(*)
begin 
	case(shift_mode)
	
		2'b00: y=rotate_out;
		2'b01: y=left_out;
		2'b10: y=rigth_out;
		2'b11: y=arith_out;
		default: y=left_out;
	endcase
		
end

//Logic Shift Left
shift_left #(w,s) ShiftLeft (
    .rin(a), 
    .rout(left_out), 
    .shamt(shamt)
    );
 
//Logic Shift Right
shift_rigth #(w,s) ShiftRigth (
    .rin(a), 
    .rout(rigth_out), 
    .shamt(shamt)
    );

//Rotate	
rotate #(w,s) Rotate (
    .rin(a), 
    .rout(rotate_out), 
    .shamt(shamt)
    );

//Arithmetic Shift Right
arithmetic_shift_rigth #(w,s) ArithmeticShiftRigth (
    .rin(a), 
    .rout(arith_out), 
    .shamt(shamt)
    );

endmodule
